#version 150
//http://www.opengl.org/wiki/GLSL_:_common_mistakes
/*  
 *  clip.frag: shader de fragmento para visualizacao MPR 
 *
 *  Copyright (C) 2013  Wu Shin-Ting, FEEC, Unicamp
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
uniform mat4 viewMatrixInv; //matriz inversa de MODELVIEW
uniform vec2 fparam;      //passo de percurso, clip
uniform vec4 scaleFactors;//fatores de escala do espaco de textura em relacao
                            // ao espaco do volume normalizado
uniform sampler3D VOLUME;   //densidades da neuroimagem 3D
uniform sampler1D TRANSFERFUNCTION; //função de transferência
in vec3 texCoord;           //coordenadas de textura
out vec4 FragColor;         //cor do fragmento

void main(void){
     vec4 texpos, initPos;
     float src, scalar;

     mat4 mvi = viewMatrixInv;
     vec4 invScaleFactors = 1./scaleFactors;

    // ponto de entrada do volume
     initPos = vec4(texCoord, 1.0)*scaleFactors;

     texpos = vec4(initPos.x, initPos.y, fparam[1], 1.0)*invScaleFactors;
     scalar = texture(VOLUME, texpos.xyz).r; // ler a densidade

     FragColor = vec4(scalar, scalar, scalar, 1.0);  // escrever a cor final do fragmento
}
