#version 150
/*  
 *  cursor.frag: shader de fragmento para desenhar eixso de cursor
 *              com opacidade
 *
 *  Copyright (C) 2013  Wu Shin-Ting, FEEC, Unicamp
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

uniform sampler2DRect DEPTHMAP;   //mapa de profundidade
uniform vec4 iparam;        // tipo de eixo
out vec4 FragColor;         //cor do fragmento

void main(void) {
    vec4 pos;
    vec4 cor;
    float alpha;

    pos.z 	= texture(DEPTHMAP, gl_FragCoord.xy).x; //volume depth texture
    pos.w	= 1.0;

    alpha = 1.0;

    if (gl_FragCoord.z > pos.z){	
       alpha = (gl_FragCoord.z-pos.z);		
       if (alpha <= 0.02)
	     alpha = 0.35;
       else if (alpha > 0.02 && alpha <= 0.1)
	     alpha = 0.25;	  
       else if (alpha > 0.1 && alpha <= 0.2)
	     alpha = 0.15;	  
       else if (alpha > 0.2 && alpha <= 0.3)
	     alpha = 0.1;	  
       else if (alpha > 0.3 && alpha <= 0.5)
	     alpha = 0.05;
       else 
	     alpha = 0.01;	  
    }

    if (iparam[0] == 0.)  // x	  
        FragColor = vec4(1.0,0.0,0.0,alpha);
    else if (iparam[0] == 1.) // y
        FragColor = vec4(0.0,1.0,0.0,alpha);
    else if (iparam[0] == 2.) // z
        FragColor = vec4(0.0,0.0,1.0,alpha);
}

